Option Strict Off
Option Explicit On
Imports System
Imports System.Windows.Forms
Imports System.Runtime.InteropServices

Imports Application = Intergraph.GeoMedia.GeoMedia.Application
Imports GMViewListeners = Intergraph.GeoMedia.PCmdMgr.GMViewListeners
Imports MapWindow = Intergraph.GeoMedia.GeoMedia.MapWindow
Imports GMMapView = Intergraph.GeoMedia.MapviewLib.GMMapView
Imports Windows = Intergraph.GeoMedia.GeoMedia.Windows
<System.Runtime.InteropServices.ProgId("TFCCommand.CalcPresure")> Public Class CalcPresure


    'Private mobjGeoApp As Object
    Private mobjGeoViewListeners As GMViewListeners

    'WIZARD: Modeless
    'Private mbImDone As Boolean
    'ENDWIZARD
    'WIZARD: MapViewListener
    'Dim MyMapWindows As New ArrayList()
    'Private MyEventServerObject As Object

    'ENDWIZARD
    Dim frmCalcPresure As New frmCalcPresure

    ReadOnly Property IsDone() As Boolean
        Get
            'WIZARD: Modeless
            ''Modeless commands must manage the IsDone property so the command manager
            ''will know whether or not your modeless command is still actively listening
            ''at some window.
            'IsDone = mbImDone
            'ENDWIZARD
        End Get
    End Property


#Region "Initialize"
    Sub Initialize(ByVal objApplication As Object, ByVal objViewListeners As Object)
        'The Initialize method is called once per command server creation.

        'Save the pointer to the Application object and the View Listeners object.
        'The application object is the top of application's automation model.
        '    Set gobjGeoApp = objApplication
        gobjGeoApp = objApplication
        mobjGeoViewListeners = objViewListeners

        'WIZARD: MapViewListener
        'mobjGeoViewListeners.Add(Nothing, Me)
        'MyEventServerObject = objApplication.CreateService("GeoMedia.EventServer")
        'ENDWIZARD

        'WIZARD: Modeless
        ''Modeless commands must manage the IsDone property so the command manager
        ''will know whether or not your modeless command is still actively listening
        ''at some window.
        'mbImDone = True
        'ENDWIZARD

        'WIZARD: HasForm
        ''Show the command's GUI on each activation.
        ''Load frmCalcPresure
        'ENDWIZARD

    End Sub
#End Region

#Region "Activate"
    Sub Activate()
        'WIZARD: MapViewListener
        'Dim mbNewActivation As Boolean = mbImDone        
        'ENDWIZARD

        'WIZARD: Modeless
        ''Modeless commands must set the IsDone property to False for each Activate.
        ''The IsDone property should be set to True when the command is finished or
        ''whenever the Deactivate method is called.
        'mbImDone = False
        'ENDWIZARD

        'WIZARD: ModalWithForm
        'Show the command's GUI on each activation.

        'WIZARD: CenterOnApp
        'frmCalcPresure.StartPosition = FormStartPosition.CenterParent 
        'ENDWIZARD

        'WIZARD: CenterOnScreen
        frmCalcPresure.StartPosition = FormStartPosition.CenterScreen
        'ENDWIZARD

         frmCalcPresure.ShowDialog()
        'ENDWIZARD

        'WIZARD: MapViewListener
        ''Register this command with the view listeners manager.
        ''Get a pointer to the active map view
        'Dim objwnds As Windows = Nothing
        'Dim objMapView as GMMapView = Nothing
        'Dim I As Integer
        'Try
        'If mbNewActivation then
        'objwnds = gobjGeoApp.Windows 
        'For I = 1 To objwnds.Count
        'If objwnds.Item(I).Type = "MapWindow" Then
        'mobjGeoViewListeners.Add(objwnds.Item(I), Me)

        ''Connect to the Map View through the event control.
        'objMapView = objwnds.Item(I).MapView
        'frmCalcPresure.EventControl1.AddMapView( objMapView, MyEventServerObject )

        ''Add this to my private collection of attached view windows
        'MyMapWindows.Add (objwnds.Item( i ))
        'End If

        'Next
        'else
        ''Command is already active, just manage collisions
        'For I = 1 To MyMapWindows.Count
        ''Try to add the view through the view listeners manager.
        ''It is the attempt to add which causes the other conflicting
        ''map view listener commands to either be removed or forced to
        ''ignore events.
        'mobjGeoViewListeners.Add (MyMapWindows(I), Me)

        'Next
        'End if
        'Catch
        'Finally

        'If (objwnds IsNot Nothing) Then
        'Marshal.ReleaseComObject( objwnds )
        'End If
        'If (objMapView IsNot Nothing) Then
        'Marshal.ReleaseComObject( objMapView )
        'End If
        'End Try
        'ENDWIZARD

        'NOTE TO COMMAND WRITER:  Insert your activation code here.

        'WIZARD: Modeless
        ''If your code self-terminates during processing, be sure to call
        ''Deactivate on yourself or do the equivalent clean-up.
        'ENDWIZARD


    End Sub
#End Region

#Region "CanDeactivate"

    Function CanDeactivate(ByVal objViewWindow As Object) As Boolean
        Marshal.ReleaseComObject(objViewWindow)
        CanDeactivate = True
    End Function
#End Region

#Region "CanEnable"

    Function CanEnable() As Boolean
        'WIZARD: CustomEnablingRequirements
        ''Since you specified that this command has custom enabling requirements
        ''you must insert the code here that determines whether or not you are
        ''ready to run now.
        'ENDWIZARD

        CanEnable = True
    End Function
#End Region

#Region "CanActivate"

    Function CanActivate() As Boolean
        'WIZARD: HasCustomStartupRequirements
        ''Since you specified that this map view listener command has custom activation
        ''requirements, you must insert the code here that determines whether or not you are
        ''able to startup given the current state of the listeners list.
        'Dim I As Long
        'Dim objViewWindow As Intergraph.GeoMedia.GeoMedia.MapWindow
        'Dim objCurCommand As Object
        'Dim lCommandType As Long
        'Dim lListenerMask As Long

        ''Get each of the map listeners
        'For I = 1 To mobjGeoViewListeners.Count
        'mobjGeoViewListeners.GetListener( I, objViewWindow, objCurCommand, lCommandType, lListenerMask)
        ''Add code here to process this map view listener.

        'Next
        'ENDWIZARD

        CanActivate = True
    End Function
#End Region

#Region "Deactivate"

    Sub Deactivate()
        'WIZARD: MapViewListener
        'Dim objActiveWindow as MapWindow = Nothing
        'Dim  objMapView as GMMapView= Nothing
        'Dim I As Long
        'Try
        'Dim NumberOfMapWindows As Integer
        'NumberOfMapWindows = MyMapWindows.Count

        ''Count backwards so that you don't end up skipping every other
        '' map window
        'For I = NumberOfMapWindows - 1 To 0 Step -1
        'RemoveView(MyMapWindows(I))
        'Next       

        'Catch

        'Finally

        'End Try
        'ENDWIZARD

        'WIZARD: Modeless
        ''Modeless commands must set the IsDone property to True
        ''whenever the Deactivate method is called.
        'mbImDone = True
        'GC.Collect()
        'GC.WaitForPendingFinalizers()
        'ENDWIZARD

    End Sub
#End Region

#Region "AddView"

    Sub AddView(ByVal objViewWindow As Object)
        'WIZARD: MapViewListener
        'Dim objMapView As GMMapView = Nothing
        'Try
        ''Add this map view window to my collection.
        'MyMapWindows.Add(objViewWindow)

        ''Register this command with the view listeners manager.
        'mobjGeoViewListeners.Add(objViewWindow, Me)


        ''Connect to the Map View through the event control.
        'objMapView = objViewWindow.MapView
        'frmCalcPresure.EventControl1.AddMapView(objViewWindow.MapView, MyEventServerObject)
        'Catch
        'Finally
        'If (objViewWindow IsNot Nothing) Then
        'Marshal.ReleaseComObject( objViewWindow )
        'End If

        'If (objMapView IsNot Nothing) Then
        'Marshal.ReleaseComObject( objMapView )
        'End If

        'End Try

        'ENDWIZARD

    End Sub
#End Region

#Region "RemoveView"
    Sub RemoveView(ByVal objViewWindow As Object)
        'WIZARD: MapViewListener
        'Dim  objMapView as GMMapView= Nothing
        'MyMapWindows.Remove( objViewWindow )        
        'Try
        'objMapView = objViewWindow.MapView 

        ''Unregister this command with the view listeners manager.
        'mobjGeoViewListeners.Remove(objViewWindow, Me)


        ''Disconnect to the Map View through the event control.
        'frmCalcPresure.EventControl1.RemoveMapView(objMapView)

        'If (MyMapWindows.Count = 0) Then
        ''Since the last view was removed, we need to go inactive.
        'mbImDone = true
        'End If
        'Catch
        'Finally
        'If (objViewWindow IsNot Nothing) Then
        'Marshal.ReleaseComObject( objViewWindow )
        'End If

        'If (objMapView IsNot Nothing) Then
        'Marshal.ReleaseComObject( objMapView )
        'End If
        'GC.Collect()
        'GC.WaitForPendingFinalizers( )
        'End Try




        'Try


        'If MyMapWindows.Count() = 0 Then
        ''Since the last view was removed, we need to go inactive.
        'mbImDone = True
        'End If
        'Catch ex As Exception

        '   End Try

        '  Try
        'Do While (Marshal.ReleaseComObject(objViewWindow) > 0)
        'Loop
        'Catch ex As Exception
        'End Try

        'ENDWIZARD
    End Sub
#End Region

#Region "IgnoreEvents"

    Sub IgnoreEvents(ByVal objViewWindow As Object)
        'WIZARD: MapViewListener
        ''Temporarily disconnect to the Map View through the event control.
        'Dim objMapView As GMMapView = Nothing
        'Try
        'objMapView = objViewWindow.MapView
        'frmCalcPresure.EventControl1.RemoveMapView(objViewWindow.MapView)
        'Catch
        'Finally
        'If (objMapView IsNot Nothing) Then
        'Marshal.ReleaseComObject(objMapView)
        'End If
        'If (objViewWindow IsNot Nothing) Then
        'Marshal.ReleaseComObject(objViewWindow)
        'End If
        'End Try
        'ENDWIZARD

    End Sub
#End Region

#Region "RestoreEvents"

    Sub RestoreEvents(ByVal objViewWindow As Object)
        'WIZARD: MapViewListener
        ''Reconnect to the Map View through the event control.
        'Dim objMapView As GMMapView = Nothing
        'Try
        'objMapView = objViewWindow.MapView
        'frmCalcPresure.EventControl1.AddMapView(objMapView, MyEventServerObject)
        'Catch
        'Finally
        'If (objMapView IsNot Nothing) Then
        'Marshal.ReleaseComObject(objMapView)
        'End If
        'If (objViewWindow IsNot Nothing) Then
        'Marshal.ReleaseComObject(objViewWindow)
        'End If
        'End Try
        'ENDWIZARD

    End Sub
#End Region

#Region "Terminate"

    Sub Terminate()
        If (gobjGeoApp IsNot Nothing) Then
            Marshal.ReleaseComObject(gobjGeoApp)
        End If
        'Perform any shutdown cleanup activities before we are released.
        ' let go local copies of application ptr and ViewListeners ptr        


        'WIZARD: MapViewListener
        'mobjGeoViewListeners.Remove(Nothing, Me)
        'If (MyEventServerObject IsNot Nothing) Then
        'Marshal.ReleaseComObject(MyEventServerObject)
        'End If
        'If (MyMapWindows.Count <> 0) Then
        'Deactivate()
        'End If
        'ENDWIZARD
        If (mobjGeoViewListeners IsNot Nothing) Then
            Marshal.ReleaseComObject(mobjGeoViewListeners)
        End If

        'WIZARD: HasForm
        ''Show the command's GUI on each activation.
        'frmCalcPresure.Close()
        'ENDWIZARD
        GC.Collect()
        GC.WaitForPendingFinalizers()

    End Sub
#End Region

#Region "Help"

    Function Help() As Boolean

        Help = False

        'WIZARD: Help
        ' There are three places a command can handle help
        ' 1) Help on a modal dialog can be handled in Form_KeyUp event
        ' 2) Help for Map View Listener can be handled in EventControl_KeyDown event
        '    This is for cases when the map view listener command is running and user
        '    presses the F1 key.
        ' 3) Context sensitive help, i.e, help when a user presses F1 or Shift F1 on the
        '    command's menu item or toolbar button.  This method handles the 3rd case.

        ' Allow commands to show context sensitive help
        ' return TRUE if help is shown by the command
        'Dim lngStatus As Long
        'Dim lngHelpContextID As Long
        ' Assign a value to lngHelpContextID before passing on to WinHelp
        'lngStatus = WinHelp(0, "xyz.hlp", HELP_CONTEXT, lngHelpContextID)
        'If (lngStatus) Then
        'Help = True
        'End If
        'ENDWIZARD

    End Function
#End Region

#Region "NotifyStartModal"

    Sub NotifyStartModal()
        'WIZARD: MapViewListener
        ''This method is called to notify that a Modal command is being started

    End Sub
#End Region

#Region "NotifyEndModal"

    Sub NotifyEndModal()
        'WIZARD: MapViewListener
        ''This method is called to notify that a Modal command has finished processing

    End Sub
#End Region
End Class





















































